#include <Reloj ds3231.h>

#FUSES NOMCLR

#use i2c(Master, fast, sda=PIN_B0, scl=PIN_B1, force_sw, STREAM=DS3231_STREAM)

#include "DS3231.c"
#include "i2c_Flex_LCD.c"

#define ajs input(PIN_D0)
#define mas input(PIN_D1)
#define menos input(PIN_D2)

int horas=0,minutos=0,segundos=0,dia=0,mes=0,anio=0,x=0,caso=0;
signed int16 temperatura=0;
char grados=223; //simbolo 
RTC_Time *reloj;

void reloj_lcd()
{
   lcd_gotoxy(1,1); printf(LCD_PUTC,"%02u:%02u:%02u  %Ld%cC",horas,minutos,segundos,temperatura,grados);
   lcd_gotoxy(1,2); printf(LCD_PUTC,"%02u/%02u/%02u",dia,mes,anio);
}


int masmenos()
{
   while(mas)
   {
      delay_ms(10);
      if(!mas)
      {
         x++;
      }
   }
   
   while(menos)
   {
      delay_ms(10);
      if(!menos)
      {
         x--;
      }
   }
   if (x==255){x=0;}
   return x;
}


void main()
{
   lcd_init(0x4E,16,2); //direccion del modulo y tamao del display lcd
   lcd_backlight_led(ON);//LED del display lcd
   
   while(TRUE)
   { 
      reloj_lcd();
      
      while(ajs)
      {
         delay_ms(10);
         if (!ajs)
         {
            caso++;
         }
      }
      
      switch (caso)
      {
         case 0:
            reloj = RTC_Get();
            horas = reloj->hours;
            minutos = reloj->minutes;
            segundos = reloj->seconds;
            dia = reloj->day;
            mes = reloj->month;
            anio = reloj->year;     
         
            temperatura = Get_Temperature()/100; 
         break;
         
         case 1:
            x=horas;
            if (horas>=0 && horas<=23)
            {
               horas=masmenos();     
            }
            if(horas>=24){horas=23; x=23;}
         break;
         
         case 2:
            x=minutos;
            if (minutos>=0 && minutos<=59)
            {
               minutos=masmenos();
            }
            if (minutos>=60){minutos=59; x=59;}
         break;
         
         case 3:
            x=segundos;
            if (segundos>=0 && segundos<=59)
            {
               segundos=masmenos();
            }
            if (segundos>=60){segundos=59; x=59;}
         break;
         
         case 4:
            x=dia;
            if (dia>=1 && dia<=31)
            {
               dia=masmenos();
            }
            if (dia>=32){dia=31; x=31;}
            if (dia==0){dia=1; x=1;}
         break;

         case 5:
            x=mes;
            if (mes>=1 && mes<=12)
            {
               mes=masmenos();
            }
            if (mes>=13){mes=12; x=12;}
            if (mes==0){mes=1; x=1;}
         break;

         case 6:
            x=anio;
            if (anio>=0 && anio<=99)
            {
               anio=masmenos();
            }
            if (anio>=100){anio=99; x=99;}
         break;
         
         case 7:
            reloj->hours   = horas;
            reloj->minutes = minutos;
            reloj->seconds = segundos;
            reloj->day  = dia;
            reloj->month = mes;
            reloj->year = anio;
            RTC_Set(reloj);
            caso=0;
         break;
         
         default:
            caso=0;
         break;
      }
   }
}

